#include "ip.h"
#include "mqtt.h"
#include "serial.h"


//mosq = mosquitto_new(CLIENT_ID, true, NULL);

void Delay_Ms()
{
    struct timespec ts;
    ts.tv_sec = 0; // 秒
    ts.tv_nsec = 100000000; // 1毫秒 = 1000000纳秒
    nanosleep(&ts,NULL);
}





void *serial_usart1(void *arg)
{ 

    serial_Receive();
    
    return NULL; 
}

void *serial_usart2(void *arg)
{ 

    serial_Receive_2();
    
    return NULL; 
}

void *AppExit(void *arg)
{ 
    unsigned char bufpwm1[3]={0x01,0x01,0x00};
    unsigned char bufpwm2[3]={0x01,0x02,0x00};
    unsigned char bufpwm3[3]={0x01,0x03,0x00};
    while(1)
    {
        Delay_Ms();
        gPwmCount++;
        if(gPwmCount>20)
        {
        gPwmCount=21;
        serial_Write(bufpwm1);
        serial_Write(bufpwm2);
        serial_Write(bufpwm3);
       
        } 
    }
    
    return NULL; 
}



int main(int argc, char *argv[]) {
    //struct mosquitto *mosq;
    int rc=0;

    serial_Init();

    gStart=time(NULL);
    // 初始化 mosquitto 库
    mosquitto_lib_init();
    mosq = mosquitto_new(CLIENT_ID, true, NULL);
    init_mqtt(mosq);

    // 连接到 MQTT 代理
    rc = mosquitto_connect(mosq, BROKER_ADDRESS, BROKER_PORT, 60);
    if (rc != MOSQ_ERR_SUCCESS) {
        fprintf(stderr, "Failed to connect to broker: %s\n", mosquitto_strerror(rc));
        mosquitto_destroy(mosq);
        return EXIT_FAILURE;
    }
   
    ipaddr();
   send_mqtt_message(mosq, TOPIC,ip_address);//将ip发送给mqtt
 

    pthread_t thread[3];//线程标识符
    
    if(pthread_create(&thread[0],NULL,serial_usart1,NULL)!=0)
    {
        perror("Failed to create thread 1");
        return 1;
    }

    if(pthread_create(&thread[1],NULL,AppExit,NULL)!=0)
    {
        perror("Failed to create thread 2");
        return 1;
    }

    if(pthread_create(&thread[2],NULL,serial_usart2,NULL)!=0)
    {
        perror("Failed to create thread 2");
        return 1;
    }
    
   
   //开始循环，处理网络流量
    //mosquitto_loop_start(mosq);//后台处理
    mosquitto_loop_forever(mosq, -1, 1000); // -1 表示无限等待，1 表示处理消息的最大数量

    // 清理
    mosquitto_destroy(mosq);
    mosquitto_lib_cleanup(); 
    // 等待线程1结束
    pthread_join(thread[0], NULL);

    // 等待线程2结束
    pthread_join(thread[1], NULL);

    // 等待线程3结束
    pthread_join(thread[2], NULL);

    return EXIT_SUCCESS;
}